#ifndef _COM_SUN_STAR_SETUP_INSTALLRESPONSE_HPP_
#define _COM_SUN_STAR_SETUP_INSTALLRESPONSE_HPP_

#ifndef _COM_SUN_STAR_SETUP_INSTALLRESPONSE_HDL_
#include <com/sun/star/setup/InstallResponse.hdl>
#endif

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#ifndef _COM_SUN_STAR_UNO_TYPE_HXX_
#include <com/sun/star/uno/Type.hxx>
#endif

#ifndef _COM_SUN_STAR_SETUP_RESPONSEERRORCODE_HPP_
#include <com/sun/star/setup/ResponseErrorCode.hpp>
#endif

namespace com
{
namespace sun
{
namespace star
{
namespace setup
{

inline InstallResponse::InstallResponse() SAL_THROW( () )
    : bSuccess(sal_False)
    , eErrorCode(::com::sun::star::setup::ResponseErrorCode_NOERROR)
    , nSizeNeeded((sal_Int32)0)
    , bReboot(sal_False)
    , bLogout(sal_False)
{
}

inline InstallResponse::InstallResponse(const sal_Bool& __bSuccess, const ::com::sun::star::setup::ResponseErrorCode& __eErrorCode, const sal_Int32& __nSizeNeeded, const sal_Bool& __bReboot, const sal_Bool& __bLogout) SAL_THROW( () )
    : bSuccess(__bSuccess)
    , eErrorCode(__eErrorCode)
    , nSizeNeeded(__nSizeNeeded)
    , bReboot(__bReboot)
    , bLogout(__bLogout)
{
}

} // setup
} // star
} // sun
} // com

#if (defined(__SUNPRO_CC) && (__SUNPRO_CC == 0x500))
static typelib_TypeDescriptionReference * s_pType_com_sun_star_setup_InstallResponse = 0;
#endif

inline const ::com::sun::star::uno::Type& SAL_CALL getCppuType( const ::com::sun::star::setup::InstallResponse* ) SAL_THROW( () )
{
    #if ! (defined(__SUNPRO_CC) && (__SUNPRO_CC == 0x500))
    static typelib_TypeDescriptionReference * s_pType_com_sun_star_setup_InstallResponse = 0;
    #endif

    if ( !s_pType_com_sun_star_setup_InstallResponse )
    {
        typelib_static_type_init( &s_pType_com_sun_star_setup_InstallResponse, typelib_TypeClass_STRUCT, "com.sun.star.setup.InstallResponse" );
    }
    return * reinterpret_cast< ::com::sun::star::uno::Type * >( &s_pType_com_sun_star_setup_InstallResponse );
}

#endif // _COM_SUN_STAR_SETUP_INSTALLRESPONSE_HPP_
