#ifndef _COM_SUN_STAR_SETUP_UNZIPACTION_HPP_
#define _COM_SUN_STAR_SETUP_UNZIPACTION_HPP_

#ifndef _COM_SUN_STAR_SETUP_UNZIPACTION_HDL_
#include <com/sun/star/setup/UnzipAction.hdl>
#endif

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#ifndef _COM_SUN_STAR_UNO_TYPE_HXX_
#include <com/sun/star/uno/Type.hxx>
#endif

#ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
#include <com/sun/star/uno/Sequence.hxx>
#endif
#ifndef _COM_SUN_STAR_SETUP_BASEACTION_HPP_
#include <com/sun/star/setup/BaseAction.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_DATETIME_HPP_
#include <com/sun/star/util/DateTime.hpp>
#endif

namespace com
{
namespace sun
{
namespace star
{
namespace setup
{

inline UnzipAction::UnzipAction() SAL_THROW( () )
    : ::com::sun::star::setup::BaseAction()
    , strSourceFilename()
    , strDestinationPath()
    , strPattern()
    , bUnoComponent(sal_False)
    , bActiveX(sal_False)
    , bOverwrite(sal_False)
    , aDateTime()
    , nRights((sal_Int32)0)
    , seqSubFiles()
{
}

inline UnzipAction::UnzipAction(const ::com::sun::star::setup::ActionType& __eType, const sal_Bool& __bDone, const sal_Bool& __bProcess, const ::rtl::OUString& __strSourceFilename, const ::rtl::OUString& __strDestinationPath, const ::rtl::OUString& __strPattern, const sal_Bool& __bUnoComponent, const sal_Bool& __bActiveX, const sal_Bool& __bOverwrite, const ::com::sun::star::util::DateTime& __aDateTime, const sal_Int32& __nRights, const ::com::sun::star::uno::Sequence< ::rtl::OUString >& __seqSubFiles) SAL_THROW( () )
    : ::com::sun::star::setup::BaseAction(__eType, __bDone, __bProcess)
    , strSourceFilename(__strSourceFilename)
    , strDestinationPath(__strDestinationPath)
    , strPattern(__strPattern)
    , bUnoComponent(__bUnoComponent)
    , bActiveX(__bActiveX)
    , bOverwrite(__bOverwrite)
    , aDateTime(__aDateTime)
    , nRights(__nRights)
    , seqSubFiles(__seqSubFiles)
{
}

} // setup
} // star
} // sun
} // com

#if (defined(__SUNPRO_CC) && (__SUNPRO_CC == 0x500))
static typelib_TypeDescriptionReference * s_pType_com_sun_star_setup_UnzipAction = 0;
#endif

inline const ::com::sun::star::uno::Type& SAL_CALL getCppuType( const ::com::sun::star::setup::UnzipAction* ) SAL_THROW( () )
{
    #if ! (defined(__SUNPRO_CC) && (__SUNPRO_CC == 0x500))
    static typelib_TypeDescriptionReference * s_pType_com_sun_star_setup_UnzipAction = 0;
    #endif

    if ( !s_pType_com_sun_star_setup_UnzipAction )
    {
        typelib_static_type_init( &s_pType_com_sun_star_setup_UnzipAction, typelib_TypeClass_STRUCT, "com.sun.star.setup.UnzipAction" );
    }
    return * reinterpret_cast< ::com::sun::star::uno::Type * >( &s_pType_com_sun_star_setup_UnzipAction );
}

#endif // _COM_SUN_STAR_SETUP_UNZIPACTION_HPP_
