#ifndef _COM_SUN_STAR_UCB_COOKIE_HPP_
#define _COM_SUN_STAR_UCB_COOKIE_HPP_

#ifndef _COM_SUN_STAR_UCB_COOKIE_HDL_
#include <com/sun/star/ucb/Cookie.hdl>
#endif

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#ifndef _COM_SUN_STAR_UNO_TYPE_HXX_
#include <com/sun/star/uno/Type.hxx>
#endif

#ifndef _COM_SUN_STAR_UCB_COOKIEPOLICY_HPP_
#include <com/sun/star/ucb/CookiePolicy.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_DATETIME_HPP_
#include <com/sun/star/util/DateTime.hpp>
#endif

namespace com
{
namespace sun
{
namespace star
{
namespace ucb
{

inline Cookie::Cookie() SAL_THROW( () )
    : Name()
    , Value()
    , Domain()
    , Path()
    , Expires()
    , Secure(sal_False)
    , Policy(::com::sun::star::ucb::CookiePolicy_CONFIRM)
{
}

inline Cookie::Cookie(const ::rtl::OUString& __Name, const ::rtl::OUString& __Value, const ::rtl::OUString& __Domain, const ::rtl::OUString& __Path, const ::com::sun::star::util::DateTime& __Expires, const sal_Bool& __Secure, const ::com::sun::star::ucb::CookiePolicy& __Policy) SAL_THROW( () )
    : Name(__Name)
    , Value(__Value)
    , Domain(__Domain)
    , Path(__Path)
    , Expires(__Expires)
    , Secure(__Secure)
    , Policy(__Policy)
{
}

} // ucb
} // star
} // sun
} // com

#if (defined(__SUNPRO_CC) && (__SUNPRO_CC == 0x500))
static typelib_TypeDescriptionReference * s_pType_com_sun_star_ucb_Cookie = 0;
#endif

inline const ::com::sun::star::uno::Type& SAL_CALL getCppuType( const ::com::sun::star::ucb::Cookie* ) SAL_THROW( () )
{
    #if ! (defined(__SUNPRO_CC) && (__SUNPRO_CC == 0x500))
    static typelib_TypeDescriptionReference * s_pType_com_sun_star_ucb_Cookie = 0;
    #endif

    if ( !s_pType_com_sun_star_ucb_Cookie )
    {
        typelib_static_type_init( &s_pType_com_sun_star_ucb_Cookie, typelib_TypeClass_STRUCT, "com.sun.star.ucb.Cookie" );
    }
    return * reinterpret_cast< ::com::sun::star::uno::Type * >( &s_pType_com_sun_star_ucb_Cookie );
}

#endif // _COM_SUN_STAR_UCB_COOKIE_HPP_
