#ifndef _COM_SUN_STAR_UCB_RECIPIENTINFO_HPP_
#define _COM_SUN_STAR_UCB_RECIPIENTINFO_HPP_

#ifndef _COM_SUN_STAR_UCB_RECIPIENTINFO_HDL_
#include <com/sun/star/ucb/RecipientInfo.hdl>
#endif

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#ifndef _COM_SUN_STAR_UNO_TYPE_HXX_
#include <com/sun/star/uno/Type.hxx>
#endif

#ifndef _COM_SUN_STAR_UCB_OUTGOINGMESSAGESTATE_HPP_
#include <com/sun/star/ucb/OutgoingMessageState.hpp>
#endif

namespace com
{
namespace sun
{
namespace star
{
namespace ucb
{

inline RecipientInfo::RecipientInfo() SAL_THROW( () )
    : ProtocolType()
    , State(::com::sun::star::ucb::OutgoingMessageState_WRITTEN)
    , To()
    , CC()
    , BCC()
    , Newsgroups()
    , Server()
    , Username()
    , Password()
    , VIMPostOfficePath()
    , ProtocolErrorString()
    , ProtocolErrorNumber((sal_Int32)0)
    , SendTries((sal_Int32)0)
{
}

inline RecipientInfo::RecipientInfo(const ::rtl::OUString& __ProtocolType, const ::com::sun::star::ucb::OutgoingMessageState& __State, const ::rtl::OUString& __To, const ::rtl::OUString& __CC, const ::rtl::OUString& __BCC, const ::rtl::OUString& __Newsgroups, const ::rtl::OUString& __Server, const ::rtl::OUString& __Username, const ::rtl::OUString& __Password, const ::rtl::OUString& __VIMPostOfficePath, const ::rtl::OUString& __ProtocolErrorString, const sal_Int32& __ProtocolErrorNumber, const sal_Int32& __SendTries) SAL_THROW( () )
    : ProtocolType(__ProtocolType)
    , State(__State)
    , To(__To)
    , CC(__CC)
    , BCC(__BCC)
    , Newsgroups(__Newsgroups)
    , Server(__Server)
    , Username(__Username)
    , Password(__Password)
    , VIMPostOfficePath(__VIMPostOfficePath)
    , ProtocolErrorString(__ProtocolErrorString)
    , ProtocolErrorNumber(__ProtocolErrorNumber)
    , SendTries(__SendTries)
{
}

} // ucb
} // star
} // sun
} // com

#if (defined(__SUNPRO_CC) && (__SUNPRO_CC == 0x500))
static typelib_TypeDescriptionReference * s_pType_com_sun_star_ucb_RecipientInfo = 0;
#endif

inline const ::com::sun::star::uno::Type& SAL_CALL getCppuType( const ::com::sun::star::ucb::RecipientInfo* ) SAL_THROW( () )
{
    #if ! (defined(__SUNPRO_CC) && (__SUNPRO_CC == 0x500))
    static typelib_TypeDescriptionReference * s_pType_com_sun_star_ucb_RecipientInfo = 0;
    #endif

    if ( !s_pType_com_sun_star_ucb_RecipientInfo )
    {
        typelib_static_type_init( &s_pType_com_sun_star_ucb_RecipientInfo, typelib_TypeClass_STRUCT, "com.sun.star.ucb.RecipientInfo" );
    }
    return * reinterpret_cast< ::com::sun::star::uno::Type * >( &s_pType_com_sun_star_ucb_RecipientInfo );
}

#endif // _COM_SUN_STAR_UCB_RECIPIENTINFO_HPP_
