#ifndef _COM_SUN_STAR_UTIL_SEARCHOPTIONS_HPP_
#define _COM_SUN_STAR_UTIL_SEARCHOPTIONS_HPP_

#ifndef _COM_SUN_STAR_UTIL_SEARCHOPTIONS_HDL_
#include <com/sun/star/util/SearchOptions.hdl>
#endif

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#ifndef _COM_SUN_STAR_UNO_TYPE_HXX_
#include <com/sun/star/uno/Type.hxx>
#endif

#ifndef _COM_SUN_STAR_LANG_LOCALE_HPP_
#include <com/sun/star/lang/Locale.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_SEARCHALGORITHMS_HPP_
#include <com/sun/star/util/SearchAlgorithms.hpp>
#endif

namespace com
{
namespace sun
{
namespace star
{
namespace util
{

inline SearchOptions::SearchOptions() SAL_THROW( () )
    : algorithmType(::com::sun::star::util::SearchAlgorithms_ABSOLUTE)
    , searchFlag((sal_Int32)0)
    , searchString()
    , replaceString()
    , Locale()
    , changedChars((sal_Int32)0)
    , deletedChars((sal_Int32)0)
    , insertedChars((sal_Int32)0)
    , transliterateFlags((sal_Int32)0)
{
}

inline SearchOptions::SearchOptions(const ::com::sun::star::util::SearchAlgorithms& __algorithmType, const sal_Int32& __searchFlag, const ::rtl::OUString& __searchString, const ::rtl::OUString& __replaceString, const ::com::sun::star::lang::Locale& __Locale, const sal_Int32& __changedChars, const sal_Int32& __deletedChars, const sal_Int32& __insertedChars, const sal_Int32& __transliterateFlags) SAL_THROW( () )
    : algorithmType(__algorithmType)
    , searchFlag(__searchFlag)
    , searchString(__searchString)
    , replaceString(__replaceString)
    , Locale(__Locale)
    , changedChars(__changedChars)
    , deletedChars(__deletedChars)
    , insertedChars(__insertedChars)
    , transliterateFlags(__transliterateFlags)
{
}

} // util
} // star
} // sun
} // com

#if (defined(__SUNPRO_CC) && (__SUNPRO_CC == 0x500))
static typelib_TypeDescriptionReference * s_pType_com_sun_star_util_SearchOptions = 0;
#endif

inline const ::com::sun::star::uno::Type& SAL_CALL getCppuType( const ::com::sun::star::util::SearchOptions* ) SAL_THROW( () )
{
    #if ! (defined(__SUNPRO_CC) && (__SUNPRO_CC == 0x500))
    static typelib_TypeDescriptionReference * s_pType_com_sun_star_util_SearchOptions = 0;
    #endif

    if ( !s_pType_com_sun_star_util_SearchOptions )
    {
        typelib_static_type_init( &s_pType_com_sun_star_util_SearchOptions, typelib_TypeClass_STRUCT, "com.sun.star.util.SearchOptions" );
    }
    return * reinterpret_cast< ::com::sun::star::uno::Type * >( &s_pType_com_sun_star_util_SearchOptions );
}

#endif // _COM_SUN_STAR_UTIL_SEARCHOPTIONS_HPP_
