/*************************************************************************
 *
 *  $RCSfile: mailread.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: pl $ $Date: 2001/09/04 17:19:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _MAILREAD_HXX
#define _MAILREAD_HXX

// include ---------------------------------------------------------------

#define _SVSTDARR_STRINGS

#ifndef _DIALOG_HXX //autogen
#include <vcl/dialog.hxx>
#endif
#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif
#ifndef _EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif
#ifndef _MENUBTN_HXX //autogen
#include <vcl/menubtn.hxx>
#endif
#ifndef _LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif
#ifndef _GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif
#ifndef _SVSTDARR_HXX
#include <svtools/svstdarr.hxx>	// SvStrings
#endif

#include <svtools/svmedit.hxx>

#include <goodies/mailenum.hxx>	// MailPriority

// forward ---------------------------------------------------------------

class MailServer;

// class MailReadOnlyDialog ----------------------------------------------

class MailReadOnlyDialog : public ModalDialog
{
private:
	CancelButton	aCloseButton;
	MenuButton		aAttachButton;
	HelpButton		aHelpButton;

	FixedText		aAddressText;
	ListBox			aAddressBox;
	FixedText		aSubjectText;
	Edit			aSubjectEdit;
	FixedText		aPrioText;
	Edit			aPrioEdit;
	FixedText		aReceiptText;
	FixedBitmap		aReceiptBitmap;
	FixedText		aMessageText;
	MultiLineEdit	aMessageEdit;
	GroupBox		aTextGroup;

	MailServer*		pServer;
	Link			aOpenHdlLink;
	SvStrings		aFileList;

#if 0 // _SOLAR__PRIVATE
	DECL_LINK( SelectHdl, Button * );
#endif

public:
	MailReadOnlyDialog( Window* pParent, MailServer& rServer );
	~MailReadOnlyDialog();

	void			SetSubject( const String& rSubject )
						 { aSubjectEdit.SetText( rSubject ); }
	void			SetMessage( const String& rMessage )
						 { aMessageEdit.SetText( rMessage ); }
	void			SetPriority( MailPriority eNewPriority );
	void			SetReceipt( BOOL bReceipt );

	void			SetSenderName( const String& rSender );
	void			AppendReceiver( const String& rReceiver )
						{	aAddressBox.InsertEntry( rReceiver ); }
	void			AppendAttach( const String& rAttachFile,
								  const String& rAttachName,
								  BOOL bURL );
	String 			GetAttachFileName();

	void			SetOpenHdl( const Link& rNewLink )
						{ aOpenHdlLink = rNewLink; }
	const Link&		GetOpenHdl() const { return aOpenHdlLink; }
};

#endif

