/*************************************************************************
 *
 *  $RCSfile: ofunodef.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:47 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _OFA_OFUNODEF_HXX
#define _OFA_OFUNODEF_HXX

/** FieldType identifier
 *
 */

#define FIELDTYPE_USER				 0  		//RES_USERFLD,
#define FIELDTYPE_FILE_NAME    		 1		//RES_FILENAMEFLD,
#define FIELDTYPE_DATABASE_NAME      2		//RES_DBNAMEFLD,
#define FIELDTYPE_DATE        		 3		//RES_DATEFLD,
#define FIELDTYPE_TIME        		 4		//RES_TIMEFLD,
#define FIELDTYPE_PAGE_NUM    		 5		//RES_PAGENUMBERFLD,
#define	FIELDTYPE_AUTHOR      		 6		//RES_AUTHORFLD,
#define	FIELDTYPE_CHAPTER    	 	 7		//RES_CHAPTERFLD,
#define	FIELDTYPE_DOC_STAT			 8		//RES_DOCSTATFLD,
#define	FIELDTYPE_GET_EXP		  	 9  		//RES_GETEXPFLD,
#define	FIELDTYPE_SET_EXP    		 10  		//RES_SETEXPFLD,
#define	FIELDTYPE_GET_REFERENCE	     11  		//RES_GETREFFLD,
#define	FIELDTYPE_HIDDEN_TEXT   	 12  		//RES_HIDDENTXTFLD,
#define	FIELDTYPE_NOTE      		 13  		//RES_POSTITFLD,
#define	FIELDTYPE_SET_REFERENCE      14  		//RES_SETREFFLD,
#define	FIELDTYPE_INPUT       		 15  		//RES_INPUTFLD,
#define	FIELDTYPE_MACRO       		 16  		//RES_MACROFLD,
#define	FIELDTYPE_DDE        		 17  		//RES_DDEFLD,
#define	FIELDTYPE_HIDDEN_PARA  		 18  		//RES_HIDDENPARAFLD,
#define	FIELDTYPE_DOC_INFO     		 19  		//RES_DOCINFOFLD,
#define	FIELDTYPE_TEMPLATE_NAME   	 20  		//RES_TEMPLNAMEFLD,
#define	FIELDTYPE_USER_EXT     		 21  		//RES_EXTUSERFLD,
#define	FIELDTYPE_REF_PAGE_SET  	 22  		//RES_REFPAGESETFLD,
#define	FIELDTYPE_REF_PAGE_GET  	 23  		//RES_REFPAGEGETFLD,
#define	FIELDTYPE_INTERNET    		 24  		//RES_INTERNETFLD, nur fuer die EditEngine
#define	FIELDTYPE_JUMP_EDIT    		 25  		//RES_JUMPEDITFLD,
#define	FIELDTYPE_SCRIPT      		 26  		//RES_SCRIPTFLD,
#define	FIELDTYPE_DATE_TIME    		 27  		//RES_DATETIMEFLD
#define	FIELDTYPE_DATABASE_NEXT_SET  28  		//RES_DBNEXTSETFLD,
#define	FIELDTYPE_DATABASE_NUM_SET   29  		//RES_DBNUMSETFLD,
#define	FIELDTYPE_DATABASE_SET_NUM   30  		//RES_DBSETNUMBERFLD,
#define FIELDTYPE_DATABASE			 31       	//RES_DBFLD,

//	RES_TABLEFLD,
//	RES_FIXDATEFLD,
//	RES_FIXTIMEFLD,
//	RES_REGFLD,
//	RES_VARREGFLD,

// ExtUserFieldType
#define	EXTUSERFIELD_GIVEN_NAME			0
#define	EXTUSERFIELD_SURNAME            1
#define	EXTUSERFIELD_INITIALS           2
#define	EXTUSERFIELD_COMPANY            3
#define	EXTUSERFIELD_STREET	            4
#define	EXTUSERFIELD_TITLE              5
#define	EXTUSERFIELD_POS                6
#define	EXTUSERFIELD_PHONE_PRIVATE	    7
#define	EXTUSERFIELD_PHONE_COMPANY      8
#define	EXTUSERFIELD_FAX                9
#define	EXTUSERFIELD_EMAIL		        10
#define	EXTUSERFIELD_COUNTRY		    11
#define	EXTUSERFIELD_ZIP                12
#define	EXTUSERFIELD_CITY		        13
#define	EXTUSERFIELD_STATE		        14

// StatisticType
#define	STATISTIC_PAGE 			0
#define	STATISTIC_PARA          1
#define	STATISTIC_WORD          2
#define	STATISTIC_CHAR          3
#define	STATISTIC_TABLE         4
#define	STATISTIC_GRAPHIC       5
#define	STATISTIC_OBJECT	    6

// DocumentInfoType

#define	DOCINFO_TIME			0
#define	DOCINFO_DESC            1
#define	DOCINFO_REVISION 		2
#define	DOCINFO_CREATION        3
#define	DOCINFO_INFO0           4
#define	DOCINFO_INFO1           5
#define	DOCINFO_INFO2           6
#define	DOCINFO_INFO3           7
#define	DOCINFO_PRINT           8
#define	DOCINFO_KEYWORDS        9
#define	DOCINFO_TOPIC           10
#define	DOCINFO_TITLE           11
#define	DOCINFO_CHANGE          12

// DocumentInfoFormatType
#define DOCINFOFORMAT_AUTHOR		0
#define DOCINFOFORMAT_TIME         	1
#define DOCINFOFORMAT_DATE         	2
#define DOCINFOFORMAT_COMPLETE     	3

// UserFieldFormatType
#define USERFIELDFORMAT_SYSTEM		0
#define USERFIELDFORMAT_TEXT        1
#define USERFIELDFORMAT_NUM         2

/**
 *
 *
 *
 */

#define LINESPACE_100 				0
#define LINESPACE_150      			1
#define LINESPACE_200      			2
#define LINESPACE_PROPORTIONAL  	3
#define LINESPACE_MINIMUM      		4
#define LINESPACE_LEADER     		5
#define LINESPACE_FIX      			6
//-------------------------------------------------------------------------

/**	Defines for the XControlCharacterInsertable interface.
 *
 */

#define TEXTCONTROLCHAR_PARAGRAPH_BREAK			0
#define TEXTCONTROLCHAR_LINE_BREAK              1
#define TEXTCONTROLCHAR_HARD_HYPHEN             2
#define TEXTCONTROLCHAR_SOFT_HYPHEN             3
#define TEXTCONTROLCHAR_HARD_SPACE              4

#endif

