/*************************************************************************
 *
 *  $RCSfile: formats.hxx,v $
 *
 *  $Revision: 1.8 $
 *
 *  last change: $Author: hr $ $Date: 2003/03/27 11:47:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SOT_FORMATS_HXX
#define _SOT_FORMATS_HXX

#ifdef _SOT_FORMATS_INCLUDE_SYSTEMFORMATS

#ifdef WNT
#include <tools/prewin.h>
#include <shlobj.h>
#include <tools/postwin.h>
#endif

#endif

#ifndef _SOT_EXCHANGE_HXX
#include <sot/exchange.hxx>
#endif

#define SOT_FORMAT_SYSTEM_START					((ULONG)0)
#define SOT_FORMAT_STRING           			((ULONG)FORMAT_STRING)
#define SOT_FORMAT_BITMAP           			((ULONG)FORMAT_BITMAP)
#define SOT_FORMAT_GDIMETAFILE          		((ULONG)FORMAT_GDIMETAFILE)
#define SOT_FORMAT_PRIVATE              		((ULONG)FORMAT_PRIVATE)
#define SOT_FORMAT_FILE                 		((ULONG)FORMAT_FILE)
#define SOT_FORMAT_FILE_LIST            		((ULONG)FORMAT_FILE_LIST)
#define SOT_FORMAT_RTF                  		((ULONG)FORMAT_RTF)

#define SOT_FORMATSTR_ID_DRAWING				((ULONG)11)
#define SOT_FORMATSTR_ID_SVXB					((ULONG)12)
#define SOT_FORMATSTR_ID_SVIM					((ULONG)13)
#define SOT_FORMATSTR_ID_XFA					((ULONG)14)
#define SOT_FORMATSTR_ID_EDITENGINE				((ULONG)15)
#define SOT_FORMATSTR_ID_INTERNALLINK_STATE   	((ULONG)16)
#define SOT_FORMATSTR_ID_SOLK 					((ULONG)17)
#define SOT_FORMATSTR_ID_NETSCAPE_BOOKMARK		((ULONG)18)
#define SOT_FORMATSTR_ID_TREELISTBOX			((ULONG)19)
#define SOT_FORMATSTR_ID_NATIVE					((ULONG)20)
#define SOT_FORMATSTR_ID_OWNERLINK				((ULONG)21)
#define SOT_FORMATSTR_ID_STARSERVER				((ULONG)22)
#define SOT_FORMATSTR_ID_STAROBJECT				((ULONG)23)
#define SOT_FORMATSTR_ID_APPLETOBJECT			((ULONG)24)
#define SOT_FORMATSTR_ID_PLUGIN_OBJECT			((ULONG)25)
#define SOT_FORMATSTR_ID_STARWRITER_30			((ULONG)26)
#define SOT_FORMATSTR_ID_STARWRITER_40			((ULONG)27)
#define SOT_FORMATSTR_ID_STARWRITER_50			((ULONG)28)
#define SOT_FORMATSTR_ID_STARWRITERWEB_40		((ULONG)29)
#define SOT_FORMATSTR_ID_STARWRITERWEB_50		((ULONG)30)
#define SOT_FORMATSTR_ID_STARWRITERGLOB_40		((ULONG)31)
#define SOT_FORMATSTR_ID_STARWRITERGLOB_50		((ULONG)32)
#define SOT_FORMATSTR_ID_STARDRAW				((ULONG)33)
#define SOT_FORMATSTR_ID_STARDRAW_40			((ULONG)34)
#define SOT_FORMATSTR_ID_STARIMPRESS_50			((ULONG)35)
#define SOT_FORMATSTR_ID_STARDRAW_50			((ULONG)36)
#define SOT_FORMATSTR_ID_STARCALC				((ULONG)37)
#define SOT_FORMATSTR_ID_STARCALC_40			((ULONG)38)
#define SOT_FORMATSTR_ID_STARCALC_50			((ULONG)39)
#define SOT_FORMATSTR_ID_STARCHART				((ULONG)40)
#define SOT_FORMATSTR_ID_STARCHART_40			((ULONG)41)
#define SOT_FORMATSTR_ID_STARCHART_50			((ULONG)42)
#define SOT_FORMATSTR_ID_STARIMAGE				((ULONG)43)
#define SOT_FORMATSTR_ID_STARIMAGE_40			((ULONG)44)
#define SOT_FORMATSTR_ID_STARIMAGE_50			((ULONG)45)
#define SOT_FORMATSTR_ID_STARMATH				((ULONG)46)
#define SOT_FORMATSTR_ID_STARMATH_40			((ULONG)47)
#define SOT_FORMATSTR_ID_STARMATH_50			((ULONG)48)
#define SOT_FORMATSTR_ID_STAROBJECT_PAINTDOC	((ULONG)49)
#define SOT_FORMATSTR_ID_FILLED_AREA			((ULONG)50)
#define SOT_FORMATSTR_ID_HTML					((ULONG)51)
#define SOT_FORMATSTR_ID_HTML_SIMPLE			((ULONG)52)
#define SOT_FORMATSTR_ID_CHAOS					((ULONG)53)
#define SOT_FORMATSTR_ID_CNT_MSGATTACHFILE 		((ULONG)54)
#define SOT_FORMATSTR_ID_BIFF_5					((ULONG)55)
#define SOT_FORMATSTR_ID_BIFF__5 				((ULONG)56)
#define SOT_FORMATSTR_ID_SYLK					((ULONG)57)
#define SOT_FORMATSTR_ID_SYLK_BIGCAPS			((ULONG)58)
#define SOT_FORMATSTR_ID_LINK					((ULONG)59)
#define SOT_FORMATSTR_ID_DIF					((ULONG)60)
#define SOT_FORMATSTR_ID_STARDRAW_TABBAR		((ULONG)61)
#define SOT_FORMATSTR_ID_SONLK					((ULONG)62)
#define SOT_FORMATSTR_ID_MSWORD_DOC 			((ULONG)63)
#define SOT_FORMATSTR_ID_STAR_FRAMESET_DOC 		((ULONG)64)
#define SOT_FORMATSTR_ID_OFFICE_DOC 			((ULONG)65)
#define SOT_FORMATSTR_ID_NOTES_DOCINFO			((ULONG)66)
#define SOT_FORMATSTR_ID_NOTES_HNOTE			((ULONG)67)
#define SOT_FORMATSTR_ID_NOTES_NATIVE			((ULONG)68)
#define SOT_FORMATSTR_ID_SFX_DOC				((ULONG)69)
#define SOT_FORMATSTR_ID_EVDF					((ULONG)70)
#define SOT_FORMATSTR_ID_ESDF					((ULONG)71)
#define SOT_FORMATSTR_ID_IDF					((ULONG)72)
#define SOT_FORMATSTR_ID_EFTP					((ULONG)73)
#define SOT_FORMATSTR_ID_EFD					((ULONG)74)
#define SOT_FORMATSTR_ID_SVX_FORMFIELDEXCH		((ULONG)75)
#define SOT_FORMATSTR_ID_EXTENDED_TABBAR		((ULONG)76)
#define SOT_FORMATSTR_ID_SBA_DATAEXCHANGE		((ULONG)77)
#define SOT_FORMATSTR_ID_SBA_FIELDDATAEXCHANGE 	((ULONG)78)
#define SOT_FORMATSTR_ID_SBA_PRIVATE_URL		((ULONG)79)
#define SOT_FORMATSTR_ID_SBA_TABED				((ULONG)80)
#define SOT_FORMATSTR_ID_SBA_TABID				((ULONG)81)
#define SOT_FORMATSTR_ID_SBA_JOIN				((ULONG)82)
#define SOT_FORMATSTR_ID_OBJECTDESCRIPTOR		((ULONG)83)
#define SOT_FORMATSTR_ID_LINKSRCDESCRIPTOR		((ULONG)84)
#define SOT_FORMATSTR_ID_EMBED_SOURCE			((ULONG)85)
#define SOT_FORMATSTR_ID_LINK_SOURCE			((ULONG)86)
#define SOT_FORMATSTR_ID_EMBEDDED_OBJ			((ULONG)87)
#define SOT_FORMATSTR_ID_FILECONTENT			((ULONG)88)
#define SOT_FORMATSTR_ID_FILEGRPDESCRIPTOR	   	((ULONG)89)
#define SOT_FORMATSTR_ID_FILENAME				((ULONG)90)
#define SOT_FORMATSTR_ID_SD_OLE					((ULONG)91)
#define SOT_FORMATSTR_ID_EMBEDDED_OBJ_OLE		((ULONG)92)
#define SOT_FORMATSTR_ID_EMBED_SOURCE_OLE		((ULONG)93)
#define SOT_FORMATSTR_ID_OBJECTDESCRIPTOR_OLE	((ULONG)94)
#define SOT_FORMATSTR_ID_LINKSRCDESCRIPTOR_OLE	((ULONG)95)
#define SOT_FORMATSTR_ID_LINK_SOURCE_OLE		((ULONG)96)
#define SOT_FORMATSTR_ID_SBA_CTRLDATAEXCHANGE	((ULONG)97)
#define SOT_FORMATSTR_ID_OUTPLACE_OBJ			((ULONG)98)
#define SOT_FORMATSTR_ID_CNT_OWN_CLIP			((ULONG)99)
#define SOT_FORMATSTR_ID_INET_IMAGE				((ULONG)100)
#define SOT_FORMATSTR_ID_NETSCAPE_IMAGE			((ULONG)101)
#define SOT_FORMATSTR_ID_SBA_FORMEXCHANGE		((ULONG)102)
#define SOT_FORMATSTR_ID_SBA_REPORTEXCHANGE		((ULONG)103)
#define SOT_FORMATSTR_ID_UNIFORMRESOURCELOCATOR ((ULONG)104)
#define SOT_FORMATSTR_ID_STARCHARTDOCUMENT_50	((ULONG)105)
#define SOT_FORMATSTR_ID_GRAPHOBJ				((ULONG)106)
#define SOT_FORMATSTR_ID_STARWRITER_60          ((ULONG)107)
#define SOT_FORMATSTR_ID_STARWRITERWEB_60       ((ULONG)108)
#define SOT_FORMATSTR_ID_STARWRITERGLOB_60      ((ULONG)109)
#define SOT_FORMATSTR_ID_STARDRAW_60            ((ULONG)110)
#define SOT_FORMATSTR_ID_STARIMPRESS_60         ((ULONG)111)
#define SOT_FORMATSTR_ID_STARCALC_60            ((ULONG)112)
#define SOT_FORMATSTR_ID_STARCHART_60           ((ULONG)113)
#define SOT_FORMATSTR_ID_STARMATH_60            ((ULONG)114)
#define SOT_FORMATSTR_ID_WMF					((ULONG)115)
#define SOT_FORMATSTR_ID_DBACCESS_QUERY         ((ULONG)116)
#define SOT_FORMATSTR_ID_DBACCESS_TABLE         ((ULONG)117)
#define SOT_FORMATSTR_ID_DBACCESS_COMMAND       ((ULONG)118)
#define SOT_FORMATSTR_ID_DIALOG_60              ((ULONG)119)
#define SOT_FORMATSTR_ID_EMF					((ULONG)120)
#define SOT_FORMATSTR_ID_BIFF_8                 ((ULONG)121)
#define SOT_FORMATSTR_ID_BMP                    ((ULONG)122)
#define SOT_FORMATSTR_ID_HTML_NO_COMMENT        ((ULONG)123)
#define SOT_FORMATSTR_ID_USER_END               SOT_FORMATSTR_ID_HTML_NO_COMMENT

#endif // _SOT_FORMATS_HXX
