/*************************************************************************
 *
 *  $RCSfile: worient.hxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: hr $ $Date: 2003/03/27 14:59:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef WORIENT_HXX
#define WORIENT_HXX

#ifndef _VALUESET_HXX //autogen
#include <svtools/valueset.hxx>
#endif

#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _SV_BUTTON_HXX //autogen
#include <vcl/imagebtn.hxx>
#endif

#ifndef _SV_GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif

#ifndef _SVX_CTRDIAL_HXX
#include <svx/ctrdial.hxx>
#endif

#ifndef _SVX_NFORIENT_HXX
#include <svx/nforient.hxx>
#endif

#ifndef _SVX_ROTMODIT_HXX
#include <svx/rotmodit.hxx>
#endif

struct SvxWinOrientation_Impl;

class SvxWinOrientation : Link

{
protected:
	SvxWinOrientation_Impl*	pImpl;

public:
	SvxWinOrientation( Window * pParent,
					const ResId & rResIdForCtrDial,
					const ResId & rResIdForBtnStackedText,
					const ResId & rResIdForOrientLabel,
					const ResId & rResIdForOrientField,
					const ResId & rResIdForVSLockModeLabel,
					const ResId & rResIdForVSLockMode,
                    const ResId & rResIdForFixedLine);
	~SvxWinOrientation();

	void			Enable();
	void			Disable();
	BOOL			IsEnabled();

	BOOL			IsStackedTxt();
	void			SetStackedTxt(BOOL bOnOff);

    BOOL            HasDegrees();
    short           GetDegrees();
	void			SetDegrees(short alpha);
    void            SetNoDegrees();

	ValueSet&		GetVSLockMode();
	BOOL			IsSelRotateMode();
	SvxRotateMode	GetRotateMode();
	void			SetRotateMode(SvxRotateMode);
    void            SetNoSelRotateMode();

    void            SetTxtStackedClickHdl( const Link& rLink );
    const Link&     GetTxtStackedClickHdl() const;

	void			HandleUpdatedSystemsettings( void );	// right now only color on aBtnTxtStacked
};

#endif

