/*************************************************************************
 *
 *  $RCSfile: urlkeys.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: hro $ $Date: 2001/07/27 07:59:23 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef __URLKEYS_HXX
#define __URLKEYS_HXX

// Defines for common keys in URL files

// ANSI version

#define A_URLSECTION_SHORTCUT	"InternetShortcut"
#define A_URLKEY_URL			"URL"
#define A_URLKEY_TITLE			"Title"
#define A_URLKEY_TARGET			"Target"
#define A_URLKEY_FRAME			"Frame"
#define A_URLKEY_OPENAS			"OpenAs"
#define A_URLKEY_SOICON			"SOIcon"
#define A_URLKEY_WIN_ICONFILE	"IconFile"
#define A_URLKEY_WIN_ICONINDEX	"IconIndex"
#define A_URLKEY_WORKDIR		"WorkingDirectory"
#define A_URLKEY_ARGUMENTS		"Arguments"
#define A_URLKEY_INTERN_ORIGURL	"[URL]"

// Unicode version

#define U_URLSECTION_SHORTCUT	L"InternetShortcut"
#define U_URLKEY_URL			L"URL"
#define U_URLKEY_TITLE			L"Title"
#define U_URLKEY_TARGET			L"Target"
#define U_URLKEY_FRAME			L"Frame"
#define U_URLKEY_OPENAS			L"OpenAs"
#define U_URLKEY_SOICON			L"SOIcon"
#define U_URLKEY_WIN_ICONFILE	L"IconFile"
#define U_URLKEY_WIN_ICONINDEX	L"IconIndex"
#define U_URLKEY_WORKDIR		L"WorkingDirectory"
#define U_URLKEY_ARGUMENTS		L"Arguments"
#define U_URLKEY_INTERN_ORIGURL	L"[URL]"

#	define URLSECTION_SHORTCUT	U_URLSECTION_SHORTCUT
#	define URLKEY_URL			U_URLKEY_URL
#	define URLKEY_TITLE			U_URLKEY_TITLE
#	define URLKEY_TARGET		U_URLKEY_TARGET
#	define URLKEY_FRAME			U_URLKEY_FRAME
#	define URLKEY_OPENAS		U_URLKEY_OPENAS
#	define URLKEY_SOICON		U_URLKEY_SOICON
#	define URLKEY_WIN_ICONFILE	U_URLKEY_WIN_ICONFILE
#	define URLKEY_WIN_ICONINDEX	U_URLKEY_WIN_ICONINDEX
#	define URLKEY_WORKDIR		U_URLKEY_WORKDIR
#	define URLKEY_ARGUMENTS		U_URLKEY_ARGUMENTS
#	define URLKEY_INTERN_ORIGURL U_URLKEY_INTERN_ORIGURL

#endif // __URLKEYS_HXX

