/*************************************************************************
 *
 *  $RCSfile: salstype.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 10:23:06 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SV_SALSTYPE_HXX
#define _SV_SALSTYPE_HXX

#ifndef _GEN_HXX
#include <tools/gen.hxx>
#endif

// -----------------
// - Sound defines -
// -----------------

#define SOUND_PLAYALL			(0xFFFFFFFFUL)

// -----------------
// - State defines -
// -----------------

#define SOUND_STATE_UNLOADED	(0x00000000UL)
#define SOUND_STATE_INVALID		(0x00000001UL)
#define	SOUND_STATE_VALID		(0x00000002UL)

// ---------------------
// - SoundNotification -
// ---------------------

enum SoundNotification 
{
	SOUND_NOTIFY_NOTHING, 
	SOUND_NOTIFY_SUCCESS,
	SOUND_NOTIFY_ABORTED,
	SOUND_NOTIFY_ERROR 
};

// ---------------
// - SoundErrors -
// ---------------

#define SOUNDERR_SUCCESS                (0x00000000UL)
#define SOUNDERR_GENERAL_ERROR          (0x00000001UL)
#define SOUNDERR_CANNOT_LOAD_DRIVER     (0x00000003UL)
#define SOUNDERR_DEVICE_LOCKED          (0x00000004UL)
#define SOUNDERR_SOUND_NOT_FOUND        (0x00000005UL)
#define SOUNDERR_HARDWARE_ERROR         (0x00000006UL)
#define SOUNDERR_OUT_OF_MEMORY          (0x00000007UL)
#define SOUNDERR_UNSUPPORTED_FUNCTION   (0x00000008UL)
#define SOUNDERR_DEVICE_NOT_FOUND       (0x00000009UL)
#define SOUNDERR_DEVICE_NOT_READY       (0x0000000aUL)
#define SOUNDERR_CANNOT_READ_SOUND      (0x0000000bUL)
#define SOUNDERR_INVALID_FILE           (0x0000000cUL)

// ------------------
// - Sound-Callback	-
// ------------------

typedef void (*SALSOUNDPROC)( void* pInst, SoundNotification eNotification, ULONG nError );

#endif // _SV_SALSTYPE_HXX
